#include  <stdlib.h>
#include  <string.h>
#include  <stdio.h>
//#include  <ctype.h>
#include  <io.h>
#include  <signal.h>

#include "lanimacros.h"
#include "watchdogclock.h"
#include "uart.h"
#include "display.h"
#include "mmc.h"
#include "fat.h"
#include "backlight.h"
#include "rc5.h"
#include "adc.h"

//#include "bild.h"


void testrc5(void);
void testadc(void);
void netstat(void);

unsigned char stringbuffer[INPUTBUFFERSIZE];
char workbuffer[INPUTBUFFERSIZE];
char *trennzeichen = " \r\n";
char *workzeiger;



int main(void)
{ 
   
	unsigned char i;
	unsigned int p1,p2,p3,p4;
	//unsigned char newchar;

	clearBit(BCSCTL1,XT2OFF);				// XT2 einschalten
	
	do 
	{
		IFG1 &= ~OFIFG;                  	// Clear OSCFault flag
		for (i = 0xFF; i > 0; i--);      	// Time for flag to set
	}
	while ((IFG1 & OFIFG) != 0);        	// OSCFault flag still set?                
	
	clearBit(BCSCTL2,SELM0 OR SELM1);
	
	setBit(BCSCTL2,SELM1);               		// MCLK  = XT2CLK (safe)	= 8.000.000 MHz
	clearBit(BCSCTL1,DIVA1 OR DIVA0);    		// ACLK  = LFXT1CLK/1   	=	 32.768 MHz
	setBit(BCSCTL2,SELS);						// SMCLK = XT2CLK 			= 8.000.000 MHz
	
	//#####################################################	
	

	initclock();			// benutzt Watchdogtimer
	inituart();				// benutzt UART0, SMCLK, P3.6 P3.7  + P4.0, P4.1
	initdisplay();			// benutzt UART1, SMCLK, TIMER A beim init, STARTET INTERRUPTS!!!
	initbacklight();		// benutzt TimerB, SMCLK
	init_DOS();
	initRC5();				// benutzt TimerA(1,2),P2.2,P2.3,Comperator 
	initadc();
	// LEDs
	
	setBit(P4DIR,BIT4|BIT5);			// 4 gruen LPM0, 5 rot read sector
	clearBit(P4OUT,BIT4|BIT5);
	//toggleBit(P4OUT,BIT4);
	//sound
	setBit(P6OUT,BIT5);
	setBit(P6DIR,BIT5);
	
	displaycolor(COLOR_WHITE,COLOR_BLACK);

	//loadbmp(0,0,"sd1:/system/start.bmp");
	
	//printf(TERM_CLS);
	//printf(TERM_HOME);
   	//printf("\n\nMSP430F149 online\n\n"); 

	//unsigned int *speicher;
	
	//speicher = malloc(sizeof(DATEI));
	
	//printf("Datei braucht %d Bytes\r\n",sizeof(DATEI));
	uprintf(display_putc,"MSP430 ONLINE\r\n");



	for(;;)
	{
		if (readstring(stringbuffer))
		{
		   
		   //######################
		   

			printf("String wird bearbeitet:\n");

			strcpy(workbuffer, stringbuffer);

			for (workzeiger = strtok(workbuffer, trennzeichen); workzeiger ;workzeiger = strtok(NULL, trennzeichen))
			{
			   //printf("Befehl: %s\n", workzeiger);
			      
			   

				if (strcmp(workzeiger , "write") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
				  
					fwrite(workzeiger);
				}
				
				if (strcmp(workzeiger , "setcursor") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
					p1 = atoi(workzeiger);
				   
					workzeiger = strtok(NULL, trennzeichen);
					p2 = atoi(workzeiger);
				   
					display_setcursor(p1,p2);
					
				}
				
				if (strcmp(workzeiger , "line") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
					p1 = atoi(workzeiger);
				   
					workzeiger = strtok(NULL, trennzeichen);
					p2 = atoi(workzeiger);
				   
					workzeiger = strtok(NULL, trennzeichen);
					p3 = atoi(workzeiger);
				   
					workzeiger = strtok(NULL, trennzeichen);
					p4 = atoi(workzeiger);
				   
				   	displayline(p1,p2,p3,p4, COLOR_WHITE);
					
				}	   
			   
				if (strcmp(workzeiger , "load") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
				  
					loadbmp(0,0,workzeiger);
				}
			   
				if (strcmp(workzeiger , "cd") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
				  
					cd(workzeiger);
				}
			   
				if (strcmp(workzeiger , "read") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
				  
					loadtxt(workzeiger);
				}
			   
				if (strcmp(workzeiger , "hexmon") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
				  
					hexmon(atol(workzeiger));
				}
			
				if (strcmp(workzeiger , "dir") == 0)
				{
					dir();
				}
			   
			   
				if (strcmp(workzeiger , "settime") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
					uhrzeit.stunde = (unsigned char)atoi(workzeiger);
				   
					workzeiger = strtok(NULL, trennzeichen);
					uhrzeit.minute = (unsigned char)atoi(workzeiger);
				   
					workzeiger = strtok(NULL, trennzeichen);
					uhrzeit.sekunde = (unsigned char)atoi(workzeiger);
				}
			  
				if (strcmp(workzeiger , "rgb") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
					p1 = atoi(workzeiger);
				   
					workzeiger = strtok(NULL, trennzeichen);
					p2 = atoi(workzeiger);
				   
					workzeiger = strtok(NULL, trennzeichen);
					p3 = atoi(workzeiger);
				   
					displayrgb(p1,p2,p3);
				}
			   
				if (strcmp(workzeiger , "led") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
					p1 =(atoi(workzeiger));
				   
					backlight(p1);
				   
				}
			   
				if (strcmp(workzeiger , "cls") == 0)
				{
					workzeiger = strtok(NULL, trennzeichen);
					displaycls(atoi(workzeiger));
				   
					printf(TERM_CLS);
					printf(TERM_HOME);
				}

			   
				if (strcmp(workzeiger , "reset") == 0)
					WDTCTL = 0;					// Reset durch falsches Passwort
			   
				if (strcmp(workzeiger , "msp430") == 0)
					printf("MSP430 ist online und wartet auf Befehle.\n");
		   
				if (strcmp(workzeiger , "gettime") == 0)
					printf("Uhrzeit: %02d:%02d:%02d \n", uhrzeit.stunde, uhrzeit.minute, uhrzeit.sekunde);
			   
				if (strcmp(workzeiger , "text") == 0)
				{
					workzeiger = strchr(workzeiger,0);
					workzeiger++;
					writestring(0,50,workzeiger++);
				}
			   
				if (strcmp(workzeiger , "help") == 0)
				{
					printf("\nMSP430F149\n"); 
					printf("----------\n"); 
					printf("settime HH MM SS\n"); 
					printf("gettime\n"); 
					printf("reset\n\n");
				   
				}

				if (strcmp(workzeiger , "eth0") == 0)
				{
					netstat();
				}
					


			   
		
			}
		   
			printf("OK\n\n");
		   
		}
	   	else
                {
			p1 = getRC5();
			if(p1 != 0xffff)
			{
				printf("%05d\r\n", p1); 
			/*
			switch(p1)
			{
				case IR_REW:
					backlightplus();
					break;
				case IR_FF:
					backlightminus();
					break;
				case IR_1:
					loadbmp(0,0,"sd1:/system/start.bmp");
					break;
				case IR_5:
					loadbmp(0,0,"sd1:/vogel/spatz.bmp");
					break;
				case IR_6:
					loadbmp(0,0,"sd1:/vogel/star.bmp");
					break;
				case IR_POWER:
					WDTCTL = 0;
					break;
				case IR_MUTE:
					displaycls(COLOR_BLACK);
					break;
				case IR_RED:
					displaycls(COLOR_RED);
					break;
				case IR_GREEN:
					displaycls(COLOR_GREEN);
					break;
				case IR_YELLOW:
					displaycls(COLOR_YELLOW);
					break;
				case IR_BLUE:
					displaycls(COLOR_BLUE);
					break;
				case IR_STOP:
					testrc5();
					break;
				case IR_TV_VCR:
					toggleBit(P4OUT,BIT5);      // LED ROT
					break;
				case IR_MEMO:
					sprintf(stringbuffer," %02d:%02d:%02d ", uhrzeit.stunde, uhrzeit.minute, uhrzeit.sekunde);
					writestring(0,0,stringbuffer);
					break;
				case IR_PLAY:
					testadc();
					break;
				case IR_PAUSE:
					pong();
					break;
				default:
					break;	   
			}
			*/
			}
			else
			{
				clearBit(P4OUT,BIT4);			// LED GRUEN
				LPM0;
				setBit(P4OUT,BIT4);
			}
		}
	}
	
}
void testrc5(void)
{
	unsigned int code,flag,adresse,befehl;
	
	while(1)
	{
		code=getRC5();
		switch (code)
		{
			case IR_MUTE:
				return;
			case 0xffff:
				break;
			default:
				befehl= code AND 0x3f;
				adresse= (code>>6) AND 0x1F;
				flag = (code>>12) AND 0x01;
				//uprintf(display_putc,"FLAG:%d ADRESSE:%2d BEFEHL:%2d\r\n",flag,adresse,befehl);
				uprintf(display_putc,"CODE   :%5d\r\n",code);
				uprintf(display_putc,"FLAG   :%5d\r\n",flag);
				uprintf(display_putc,"ADRESSE:%5d\r\n",adresse);
				uprintf(display_putc,"BEFEHL :%5d\r\n",befehl);
				uprintf(display_putc,"                \r\n");
		}
	}
}


void testadc(void)
{
	static unsigned int ADCresult; 
	static unsigned long int DegC, DegF;
	
	while(getRC5()==0xFFFF)
	{
					
	ADCresult = adcsample(INCH_10);
	DegC = ((((long)ADCresult-1615)*704)/4095);
	DegF = ((DegC * 9/5)+32);           // Calculate DegF
	//sprintf(stringbuffer,"Temp: %ld C (%ld F) %04d\n", DegC, DegF, ADCresult);
	uprintf(display_putc,"%04d\r\n",ADCresult);
	//sprintf(stringbuffer," %04d",ADCresult);
	//writestring(0,0,stringbuffer);
	}
}

void netstat(void)
{
	unsigned int download,upload;	
	unsigned int downalt=200,upalt=25;
	//unsigned int downmax=400,upmax=50;
	displaycls(COLOR_BLACK);
	
	display_setcursor(1,120);
	uprintf(display_putc,"DOWNLOAD:");
	
	display_setcursor(1,110);
	uprintf(display_putc,"UPLOAD  :");
	
	displaybox(0,0,16,downalt/4,COLOR_GREEN);
	displaybox(50,0,66,upalt,COLOR_RED);

	for(;;)
	{
		if (readstring(stringbuffer))
		{
			workzeiger = strtok(stringbuffer, trennzeichen);
			download = atoi(workzeiger);
				   
			workzeiger = strtok(NULL, trennzeichen);
			upload = atoi(workzeiger);

			if (download>downalt)
				displaybox(0,downalt/4,16,download/4,COLOR_GREEN);
			
			if (download<downalt)
				displaybox(0,download/4,16,downalt/4,COLOR_BLACK);
				
			if (upload>upalt)
				displaybox(50,upalt,66,upload,COLOR_RED);
			
			if (upload<upalt)
				displaybox(50,upload,66,upalt,COLOR_BLACK);
			
			display_setcursor(60,120);
			uprintf(display_putc,"%3d",download);
			
			display_setcursor(60,110);
			uprintf(display_putc,"%3d",upload);
			
			downalt=download;
			upalt=upload;


//uprintf(display_putc,"DOWN: %3d  UP: %3d\r\n",download,upload);
			
			
		}
		else
		{
			clearBit(P4OUT,BIT4);			// LED GRUEN
			LPM0;
			setBit(P4OUT,BIT4);
		}
	}
}

