
//#include  <stdlib.h>
//#include  <string.h>
//#include  <stdio.h>
//#include  <ctype.h>
#include  <io.h>
#include  <signal.h>

#include "lanimacros.h"
#include "rc5.h"


void initadc(void)
{
	//setBit(P6SEL,0xFF);
	
	ADC12CTL0 = ADC12ON + REFON + REF2_5V + SHT0_6; // Setup ADC12, ref., sampling time + SHT0_15 + SHT1_15
	//ADC12CTL0 = ADC12ON + REFON + REF2_5V + SHT0_6; // Setup ADC12, ref., sampling time + SHT0_15 + SHT1_15
	ADC12CTL1 = SHP ;                      // Use sampling timer
	//ADC12CTL1 = SHP + ADC12SSEL0;                      // Use sampling timer
	ADC12MCTL0 = INCH_11; //+SREF_1;          // Select channel A10, Vref+
//	ADC12IE = 0x01;                       // Enable ADC12IFG.0

	ADC12CTL0 |= ENC;                     // Enable conversions
}


unsigned int adcsample(unsigned char channel)
{
	if(channel>11)
		return 0;
	
	clearBit(ADC12CTL0,ENC);                 // disable conversions
	
	//ADC12MCTL0 = channel + SREF_1;			 // geht nur wenn ENC=0
	ADC12MCTL0 = channel ;			 // geht nur wenn ENC=0
	
	setBit(ADC12CTL0,ENC);                   // Enable conversions
	
	setBit(ADC12CTL0,ADC12SC);               // Start conversion

	
	//while ((ADC12IFG & BIT0)==0);
	while ((ADC12CTL1 & ADC12BUSY) == 1);
	
	return ADC12MEM0; 
}

