
#define COLOR_WHITE 	0xffff
#define COLOR_BLACK 	0x0000
#define COLOR_RED 		0xf800
#define COLOR_GREEN 	0x07e0
#define COLOR_BLUE 		0x001f

#define COLOR_YELLOW	COLOR_RED|COLOR_GREEN
#define COLOR_MAGENTA	COLOR_RED|COLOR_BLUE
#define COLOR_CYAN		COLOR_GREEN|COLOR_BLUE

void initdisplay(void);
void displaycommand(unsigned int);
void displaydata(unsigned int);
void displaycls(unsigned int farbe);

void displayrgb(unsigned int r, unsigned int g, unsigned int b);
void displaycolor(unsigned int farbe1, unsigned int farbe2);
void displayset(unsigned int x, unsigned int y);
void displayplot(unsigned int x, unsigned int y, unsigned int farbe);
void write(unsigned int x, unsigned int y, char c);
void writestring(unsigned int x, unsigned int y, unsigned char *text);

void displayline(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, unsigned int farbe);
void displaybox(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned int farbe);

void displaypic(unsigned int x1, unsigned int y1, 
				unsigned int x2, unsigned int y2,
				unsigned int kompression,
				unsigned int *farbtabelle, unsigned char *daten);

void displaysetfont(unsigned int nummer);
//void displayicon(unsigned int x1, unsigned int y1, unsigned int nummer);
void display_setcursor(unsigned int x, unsigned int y);

unsigned int color(unsigned int r, unsigned int g, unsigned int b);

int display_putc(int c);

void timerdelay(unsigned int zeit);
