

#include  <io.h>
#include  <signal.h>

#include "lanimacros.h"
#include "watchdogclock.h"





void initclock(void)
{
	uhrzeit.stunde=23;
	uhrzeit.minute=59;
	uhrzeit.sekunde=45;
	//uhrzeit.tag=9;
	//uhrzeit.monat=9;
	//uhrzeit.jahr=1968;
	WDTCTL = WDT_ADLY_1000;   // WDT 1000ms, ACLK, interval timer
	IE1 |= WDTIE;
}


// Watchdog Timer interrupt service routine
interrupt (WDT_VECTOR) wakeup watchdog_timer(void)
{
	if (++uhrzeit.sekunde == 60)
	{
		uhrzeit.sekunde = 0;
		if (++uhrzeit.minute == 60)
		{
			uhrzeit.minute = 0;
			if (++uhrzeit.stunde == 24)
			{
				uhrzeit.stunde = 0;
			}
		}
	}
}
